#include <stdio.h>
#include <qdos.h>

#ifdef OOZ
char _PROG_NAME[] = "ooz";
long _STACK       = 2048L;
long _MEMINCR     = 512L;
#else
char _PROG_NAME[] = "zoo";
long _STACK       = 5120L;
long _MEMINCR     = 2048L;
#endif
char *_ENDMSG     = NULL;
char _BUFSIZE     = 1024;

int redirected;   /* global variable */


void spec_init(void)
{
   chanid_t chid;
   struct QLRECT w;

   redirected = !(isatty(fileno(stdout)) && !isnoclose((int)fileno(stdout)));
   chid = getchid((int)fileno(stdout));

   #ifdef OOZ
   w.q_width = 400;  w.q_height = 44;
   w.q_x = 56;  w.q_y = 60;
   #else
   w.q_width = 462;  w.q_height = 232;
   w.q_x = 25;  w.q_y = 5;
   #endif

   if (!redirected) {
      sd_wdef( chid, -1, 0, 0, &w );
      sd_clear( chid, -1 );
      sd_bordr( chid, -1, RED_M4, 1);
      sd_setin( chid, -1, WHITE_M4);
      sd_setsz( chid, -1, 2, 1);
      #ifdef OOZ
      puts("            OOZ v2.1");
      #else
      puts("              ZOO v2.1");
      #endif
      sd_setsz( chid, -1, 0, 0);
      #ifndef OOZ
      sd_setin( chid, -1, RED_M4);
      printf("               ported by Franz Herrmann, 08 Jul 1992\n\n");
      #endif
      sd_setin( chid, -1, GREEN_M4);
      sd_cure( chid, -1 );
   }
   fflush(stdout);
}

    
void zooexit(int i)
{
   char c;

   if (!redirected) {
      fflush(stdout);
      sd_cure(getchid((int)fileno(stdout)),-1);
      io_fbyte( getchid((int)fileno(stdout)),3000,&c );
      sd_curs( getchid((int)fileno(stdout)),-1 );
   }
   exit(i);
}


int chmod (void)
{
   return 0;
}


int isuadir (char *s)
{
   FILE *fp;
   int ok;

   fp = fopen(s, "r");
   ok = isadir(fp);
   fclose(fp);

   return ok;
}


unsigned long getfattr (FILE *fp)
{
   struct qdirect header;
   unsigned long fattr = 0L;

   if (fqstat((int)fileno(fp), &header)) beep(10000,200);
   if (!header.d_type) return 0L;
   fattr = (unsigned long)header.d_datalen;
   return fattr | (1L << 22);
}


int setfattr (char *f, unsigned long a)
{
   struct qdirect header;
   chanid_t chid;
   FILE *fp;

   fp = fopen(f, "r+w");
   chid = getchid((int)fileno(fp));

   fqstat((int)fileno(fp), &header);
   if (a) {
      header.d_type = 1;
      header.d_datalen = (long)(a - 4194304L);
      fs_heads(chid, -1L, (char *)&header, 14);
   }

   fclose(fp);
   return 0;
}

#if 0
void dump_qdirect (struct qdirect *q)
{
    printf("qdirect dump, address = %p\n", q);
    printf("d_length   = %d\n", q->d_length);
    printf("d_type     = %d\n", q->d_type);
    printf("d_datalen  = %d\n", q->d_datalen);
    printf("d_szname   = %d\n", q->d_szname);
    printf("d_update   = %d\n", q->d_update);
}
#endif


